/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package college;

/**
 * This class defines a Person object.
 * @author Daryle Niedermayer I.S.P., PMP
 * @version 1.0 2008/05/05 
 */

public class Person {
    
    private String nationalID;
    private String firstName;
    private String lastName;
    private String address;
    private String mobileNumber;
    private String homeNumber;
    private String workNumber;
    private char gender;
    private int birthYear;


    /** Creates a new instance of Person
     * Default constructor
     */
    public Person() {}

    /** Creates a new instance of Person 
     * 
     @param nationalID The person's National ID number
     */
    public Person(String nationalID) {
        this.nationalID = nationalID;
    }
    
    /** Creates a new instance of Person
     * 
     * @param firstName The person's first name
     * @param lastName The person's last name
     */
    public Person(String firstName, String lastName) {
        this.firstName = firstName;
        this.lastName = lastName;
    }
    
 /** Creates a new instance of Person
  * 
  * @param nationalID The person's National ID number
  * @param firstName The person's first name
  * @param lastName The person's last name
  */   
    public Person(String nationalID, String firstName, String lastName) {
        this.nationalID = nationalID;
        this.firstName = firstName;
        this.lastName = lastName;
    }

    /** Accessor method gets the instance's NationalID string
     * 
     * @return nationalID
     */
    public String getNationalID(){
        return this.nationalID;
    }
    
    /**
     * Mutator method to set the instance's National ID string
     * @param nationalID 
     */
    public void setNationalID(String nationalID) {
        this.nationalID = nationalID;
    }

    /** Accessor method gets the instance's First Name string
     * 
     * @return firstName
     */
    public String getFirstName(){
        return this.firstName;
    }

        /**
     * Mutator method to set the instance's National ID string
         * @param firstName 
         */
     public void setFirstName(String firstName) {
         this.firstName = firstName;
     }
    
    /** Accessor method gets the instance's Last Name string
     * 
     * @return lastName
     */

    public String getLastName(){
        return this.lastName;
    }
    
    /** Mutator method to set lastName
     * 
     * @param lastName
     */
    public void setLastName(String lastName) {
        this.lastName = lastName;
    }

    /** Accessor method gets the instance's Address string
     * 
     * @return address
     */
    public String getAddress(){
        return this.address;
    }

    /** Mutator method to set the instance's Address
     * 
     * @param address 
     */
    public void setAddress(String address) {
        this.address = address;
    }   

    /** Accessor method gets the instance's Mobile Number
     * 
     * @return mobileNumber
     */
    public String getMobileNumber(){
        return this.mobileNumber;
    }

    /** Mutator method to set the instance's Mobile Number
     * 
     * @param mobileNumber 
     */
    public void setMobileNumber(String mobileNumber){
        this.mobileNumber = mobileNumber;
    }

    /** Accessor method gets the instance's Home Number
     * 
     * @return homeNumber
     */
    public String getHomeNumber(){
        return this.homeNumber;
    }

    /** Mutator method to set the instance's Home Number
     * 
     * @param homeNumber 
     */
    public void setHomeNumber(String homeNumber){
        this.homeNumber = homeNumber;
    }

    /** Accessor method gets the instance's Work Number
     * 
     * @return workNumber
     */
    public String getWorkNumber(){
        return this.workNumber;
    }

    /** Mutator method sets the instance's Work Number
     * 
     * @param workNumber
     */
    public void setWorkNumber(String workNumber){
        this.workNumber = workNumber;
    }
    
    /** Accessor method gets the instance's gender
     * 
     * @return gender
     */    
    public char getGender() {
        return gender;
    }

    /** Mutator method sets the instance's gender to one of 'F' or 'M'
     * 
     * @param gender Can be of the value 'f','F','m', or 'M'. Values
     *        will be converted to uppercase.
     * @throws java.lang.Exception If value is an invalid gender, sets gender
     *        to a sentinel value of '-' before throwing the exception.
     */
    public void setGender(char gender) throws Exception {
        if (gender == 'm') {gender = 'M';}
        if (gender == 'f') {gender = 'F';}
        if (gender != 'M' || gender != 'F') {
            gender = '-';
            throw new Exception("Gender value invalid: " + new Character(gender).toString());
        }
    } 

    /** Accessor method gets the instance's Date of Birth
     * 
     * @return dateofbirth
     */
    public int getDateOfBirth() {
        return birthYear;
    }
    
    /** Mutator method sets the instance's Date of Birth
     * 
     * @param year
     * @param month
     * @param day
     */
    public void setDateOfBirth(int year) {
        this.birthYear = year;
    }
    
}
